#include "convert.h"
#include <iostream>
#include <new>
#include <limits.h>

using namespace std ;

static void delBignum( Node *x )
{
    if( x!=0 ) {
        delBignum( x->next ) ;
        delete x ; }
}


static void strToBignum( char *p, Node *&a, bool &success )
{
    a = 0 ;
    while( *p != 0 ) {
        Node *temp = new(nothrow) Node ;
        if( temp == 0 ) { success = false ; return ; }
        temp->digit = *p - '0' ;
        temp->next = a ;
        a = temp ;
        p += 1 ; }
    success = true ;
}

static void printBignum1( Node *a ) {
    if( a!=0 ) {
        printBignum1( a->next ) ;
        cout << (char) ('0' + a->digit) ; }
}

static void printBignum( Node *a ) {
    if( a==0 ) { cout << "0" ; }
    else { printBignum1( a ) ; }
}

static bool equalBigNums( Node *a, Node *b) {
    if( a==0 || b==0 ) return a==b ;
    else return a->digit==b->digit && equalBigNums( a->next, b->next ) ;
}

int testCount() { return 7 ; }

// doTest  --- do one test //
/////////////////////////////
void doTest( int testNumber, int &result ) {
    try {
        bool pass ;
        cout << "Test " << testNumber << "\n" ;
        switch( testNumber ) {
        case 0 : {
            // An easy one.
            unsigned long int i = 876543 ;
            Node *head ;
            bool ok = false ;
            int_2_list( i, head, ok ) ;
            cout << "Your answer: " ; printBignum( head ) ;
            cout << "\n" ;

            bool ok2 ;
            Node *answer ;
            strToBignum( "876543", answer, ok2 ) ;

            cout << "My answer: " ; printBignum( answer ) ;
            cout << "\n" ;

            pass = ok && equalBigNums( head, answer ) ;
        } break ;
        case 1 : {
            // The biggest we can do.
            unsigned long int i = ULONG_MAX ;
            Node *head ;
            bool ok = false ;
            int_2_list( i, head, ok ) ;
            cout << "Your answer: " ; printBignum( head ) ;
            cout << "\n" ;

            bool ok2 ;
            Node *answer ;
            strToBignum( "4294967295", answer, ok2 ) ;

            cout << "My answer: " ; printBignum( answer ) ;
            cout << "\n" ;

            pass = ok && equalBigNums( head, answer ) ;

        } break ;
        case 2 : {
            // The smallest there is.
            unsigned long int i = 0 ;
            Node *head ;
            bool ok = false ;
            int_2_list( i, head, ok ) ;
            cout << "Your answer: " ; printBignum( head ) ;
            cout << "\n" ;

            bool ok2 ;
            Node *answer ;
            strToBignum( "", answer, ok2 ) ;

            cout << "My answer: " ; printBignum( answer ) ;
            cout << "\n" ;

            pass = ok && equalBigNums( head, answer ) ;
        } break ;
        case 3 : {
           // The biggest we can do.
            bool ok2 ;
            Node *big ;
            strToBignum( "4294967295", big, ok2 ) ;

            unsigned long int i;
            bool ok = false ;
            list_2_int( big, i, ok ) ;
            cout << "Your answer: " << i ;
            cout << "\n" ;

            cout << "My answer: " << ULONG_MAX ;
            cout << "\n" ;

            pass = ok && i==ULONG_MAX ;
       } break ;
        case 4 : {
           // The smallest we can't do
            bool ok2 ;
            Node *bigger ;
            strToBignum( "4294967296", bigger, ok2 ) ;

            unsigned long int i;
            bool ok = false ;
            list_2_int( bigger, i, ok ) ;
            cout << "Your ok: " << (ok?"true":"false") ;
            cout << "\n" ;
            pass = ! ok ;
        } break ;
        case 5 : {
           // The smallest we can
            bool ok2 ;
            Node *zero ;
            strToBignum( "", zero, ok2 ) ;

            unsigned long int i;
            bool ok = false ;
            list_2_int( zero, i, ok ) ;
            cout << "Your answer: " << i ;
            cout << "\n" ;

            cout << "My answer: " << 0 ;
            cout << "\n" ;

            pass = ok && i==0 ;
        } break ;
        case 6 : {
           // A really really one one
            bool ok2 ;
            Node *bigger ;
            strToBignum( "429496729642949672964294967296", bigger, ok2 ) ;

            unsigned long int i;
            bool ok = false ;
            list_2_int( bigger, i, ok ) ;
            cout << "Your ok: " << (ok?"true":"false") ;
            cout << "\n" ;
            pass = ! ok ;
        } break ;
        default : pass = false ;
        } 

        if( pass ) {
            cout << "Test " << testNumber << " passes\n" ;
            result = 0 ; }
        else {
            cout << "Test " << testNumber << " fails\n" ;
            result = 1 ; } }
    catch( ... ) {
        cerr << "Sorry an unanticipated exception occurred\n" ;
        result = 1 ; } }